//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * テキスト入出力テストヘッダ
 * @author Junpee
 */

#ifndef TEXT_IO_TEST_H_
#define TEXT_IO_TEST_H_

#include <LampUnit/TestCase.h>

namespace Lamp{
	class TextWriter;
	class TextReader;
}

//------------------------------------------------------------------------------
/**
 * テキスト入出力テスト
 */
class TextIOTest : public TestCase{
public:
	/**
	 * コンストラクタ
	 * @param name テストの名前
	 */
	explicit TextIOTest(String name) : TestCase(name){}

	/**
	 * テストを実行する
	 */
	virtual void runTest(){}

	/**
	 * テストスィートの取得
	 * @return テストスィート
	 */
	static Test* suite();

	// ファイル入出力テスト
	virtual void testFileIO();

	// メモリ入出力テスト
	virtual void testMemoryIO();

private:
	// 通常書き込み
	virtual void basicWrite(TextWriter* writer);

	// 通常読み込み
	virtual void basicRead(TextReader* reader);

	// CRLF書き込み
	virtual void crlfWrite(TextWriter* writer);

	// CRLF読み込み
	virtual void crlfRead(TextReader* reader);

	// CR書き込み
	virtual void crWrite(TextWriter* writer);

	// CR読み込み
	virtual void crRead(TextReader* reader);

	// LF書き込み
	virtual void lfWrite(TextWriter* writer);

	// LF読み込み
	virtual void lfRead(TextReader* reader);

	// abc書き込み
	virtual void abcWrite(TextWriter* writer);

	// abc読み込み
	virtual void abcRead(TextReader* reader);

	// 空書き込み
	virtual void emptyWrite(TextWriter* writer);

	// 空読み込み
	virtual void emptyRead(TextReader* reader);

};

//------------------------------------------------------------------------------
#endif // End of TEXT_IO_TEST_H_
//------------------------------------------------------------------------------
